;; Txt2Att  ( Lee Mac )
;; Converts Single-line Text to Attribute Definition

(defun c:T2A ( / StringSubst RemovePairs ss ent eLst str dx73 )
  (vl-load-com)
  ;; Lee Mac  ~  27.04.10

  (defun StringSubst ( new pat str )
    (while (vl-string-search pat str)
      (setq str (vl-string-subst new pat str))
    )
    str
  )

  (defun RemovePairs ( lst pairs )
    (vl-remove-if
      (function
        (lambda ( pair )
          (vl-position (car pair) pairs)
        )
      )
      lst
    )
  )

  (if (setq ss (ssget "_:L" '((0 . "TEXT"))))
    
    ( (lambda ( i )
        
        (while (setq ent (ssname ss (setq i (1+ i))))
          (setq eLst (entget ent)
                str  (StringSubst "_" " " (cdr (assoc 1 eLst)))
                dx73 (cdr (assoc 73 eLst)))

          (setq eLst (RemovePairs eLst '( 0 100 1 73 )))

          (if (entmake (append '( (0 . "ATTDEF") ) eLst (list (cons 70    0)
                                                              (cons 74 dx73)
                                                              (cons 1   str)
                                                              (cons 2   str)
                                                              (cons 3   str))))
            (entdel ent)
          )
        )
      )
      -1
    )
  )

  (princ))

;Converts attributes (attr. definitions, tags) to plain texts
(defun C:A2T ( / ss ssl i e new grp grplst addg)
  (setq ss (ssget '((0 . "ATTDEF"))))
  (setq ssl (sslength ss)  i 0)
  (setq grplst (list 7 8 10 11 39 40 41 50 51 62 71 72 73))
  (while (< i ssl)
    (setq e (ssname ss i))
    (setq ent (entget e))
    (setq new '((0 . "TEXT")))
    (setq new (append new (list (cons 1 (cdr (assoc 2 ent))))))
    (foreach grp grplst
      (setq addg (assoc grp ent))
      (if (/= addg nil)
        (setq new (append new (list (assoc grp ent))))
      )
    )
    (entmake new)
    (entdel e)
    (setq i (1+ i))
  )
  (princ)
)
