(defun c:QAB (/)
 ;; Close all but active drawing (with option to save inactive)
 ;; Express Tool subroutine "ACET-UI-Message" required
 ;; Alan J. Thompson, 06.09.10
 ((lambda (save)
    (vlax-for x (vla-get-documents
                  (cond (*Acad*)
                        ((setq *Acad* (vlax-get-acad-object)))
                  )
                )
      (or (eq :vlax-true (vla-get-active x))
          (vl-catch-all-apply (function vla-close) (list x save))
      )
    )
  )
   (if (eq 6 (acet-ui-message "Save drawings before closing?" "Close All But Active Drawing" 52))
     :vlax-true
     :vlax-false
   )
 )
 (princ)
)